# Keybindings and macros activated upon entering TeX mode
# Richard T. Austin (austin@eecs.umich.edu)
# version 1.0 (8/12/92)
#
# See the latex file "keyboard.tex" (in the "Help" folder) for an 
# introduction, or "Latex Keys Help" in the Help menu for on-line help.
#
# If you make improvements to this file, please share them with me!
#                                 Richard
#
 


# 
# Special macros follow.  Most of these are equation-related.
#

proc subscript {} {
	insertText "_{}"
	backwardChar
	backwardChar
}
proc cite {} {
	insertText "~\\cite{}"
	backwardChar
	backwardChar
}
proc ref {} { 
	insertText "\\ref{}"
	backwardChar
	backwardChar
}
proc alignEqual {} {
	insertText " &=& "
}
proc noNumber {} {
	insertText "\\nonumber \\\\"
}
proc scriptL {} {
	insertText "\\ell "
}
proc boldface {} {
      insertText "{\\bf }"
	backwardChar
	backwardChar
}
proc emphasize {} {
      insertText "{\\em }"
	backwardChar
	backwardChar
}
proc underline {} {
	insertText "\\underline{}"
	backwardChar
	backwardChar
}
proc conjugate {} {
	insertText "^{*}"
}
proc sum {} {
      insertText "\\sum_{}^{}"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc mbox {} {
      insertText "\\mbox{}"
	backwardChar
	backwardChar
}
proc overline {} {
      insertText "\\overline{}"
	backwardChar
	backwardChar
}
proc infinity {} {
      insertText "\\infty "
}
proc bigBrackets {} {
      insertText "\\left\[  \\right\]"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc item {} {
      insertText "\\item "
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
}
proc cross {} {
      insertText "\\times "
}
proc squareRoot {} {
      insertText "\\sqrt{}"
	backwardChar
	backwardChar
}
proc fraction {} {
      insertText "\\frac{}{}"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc superscript {} {
      insertText "^{}"
	backwardChar
	backwardChar
}
proc integral {} {
      insertText "\\int_{}^{}"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc mathMode {} {
      insertText "$$"
	backwardChar
	backwardChar
}
proc hat {} {
      insertText "\\hat{}"
	backwardChar
	backwardChar
}
proc tilde {} {
      insertText "\\tilde{}"
	backwardChar
	backwardChar
}
proc bigParens {} {
      insertText "\\left(  \\right)"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc bigBraces {} {
      insertText "\\left\\{  \\right\\}"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc expectedValue {} {
      insertText "\\langle  \\rangle"
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
	backwardChar
}
proc equation {} {
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "% equation"
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "\\begin{equation}"
      carriageReturn
      insertText "\\label{}"
      carriageReturn
      insertText ""
      carriageReturn
      insertText "\\end{equation}"
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      previousLine
      previousLine
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
}
proc displaymath {} {
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "% displaymath"
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "\\begin{displaymath}"
      carriageReturn
      carriageReturn
      insertText "\\end{displaymath}"
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      previousLine
}
proc eqnarray {} {
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "% eqnarray"
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "\\begin{eqnarray}"
      carriageReturn
      insertText "\\label{}"
      carriageReturn
      insertText ""
      carriageReturn
      insertText "\\end{eqnarray}"
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      previousLine
      previousLine
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
      forwardChar
}
proc eqnarrayStar {} {
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "% eqnarray*"
      carriageReturn
      insertText "%"
      carriageReturn
      insertText "\\begin{eqnarray*}"
      carriageReturn
      carriageReturn
      insertText "\\end{eqnarray*}"
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      previousLine
}
proc environment {} {
      set one [prompt "Begin what environment?" "slide"] 
      carriageReturn
      insertText "\\begin{"
      insertText $one
      insertText "}"
      carriageReturn
      carriageReturn
      insertText "\\end{"
      insertText $one
      insertText "}"
      carriageReturn
      insertText ""
      backwardChar
      previousLine
      previousLine
}
proc alpha {} {
	insertText "\\alpha "
}
proc beta {} {
	insertText "\\beta "
}
proc chi {} {
	insertText "\\chi "
}
proc delta {} {
	insertText "\\delta "
}
proc capDelta {} {
	insertText "\\Delta "
}
proc epsilon {} {
	insertText "\\epsilon "
}
proc varepsilon {} {
	insertText "\\varepsilon "
}
proc phi {} {
	insertText "\\phi "
}
proc varphi {} {
	insertText "\\varphi "
}
proc capPhi {} {
	insertText "\\Phi "
}
proc gamma {} {
	insertText "\\gamma "
}
proc capGamma {} {
	insertText "\\Gamma "
}
proc eta {} {
	insertText "\\eta "
}
proc iota {} {
	insertText "\\iota "
}
proc partial {} {
	insertText "\\partial "
}
proc kappa {} {
	insertText "\\kappa "
}
proc lambda {} {
	insertText "\\lambda "
}
proc capLambda {} {
	insertText "\\Lambda "
}
proc mu {} {
	insertText "\\mu "
}
proc nu {} {
	insertText "\\nu "
}
proc pi {} {
	insertText "\\pi "
}
proc capPi {} {
	insertText "\\Pi "
}
proc theta {} {
	insertText "\\theta "
}
proc capTheta {} {
	insertText "\\Theta "
}
proc vartheta {} {
	insertText "\\vartheta "
}
proc rho {} {
	insertText "\\rho "
}
proc sigma {} {
	insertText "\\sigma "
}
proc capSigma {} {
	insertText "\\Sigma "
}
proc tau {} {
	insertText "\\tau "
}
proc upsilon {} {
	insertText "\\upsilon "
}
proc capUpsilon {} {
	insertText "\\Upsilon "
}
proc nabla {} {
	insertText "\\nabla "
}
proc omega {} {
	insertText "\\omega "
}
proc capOmega {} {
	insertText "\\Omega "
}
proc xi {} {
	insertText "\\xi "
}
proc capXi {} {
	insertText "\\Xi "
}
proc psi {} {
	insertText "\\psi "
}
proc capPsi {} {
	insertText "\\Psi "
}
proc zeta {} {
	insertText "\\zeta "
}

proc funcTab {} {
	setVar matchWords 0
	setVar forward 1
	setVar regExpr 0
	setVar ignoreCase 1
	set pos [getPos]
	eval select [search {} $pos] 
	goto [selEnd]
	backwardChar
	deleteChar
}

proc unbindTexKeys {} {
}

menu	LaTeX {
	{menu Greek {
		"alpha"
		"beta"
		"gamma"
		"capGamma"
		"delta"
		"capDelta"
		"epsilon"
		"varepsilon"
		"zeta"
		"eta"
		"theta"
		"vartheta"
		"capTheta"
		"iota"
		"kappa"
		"lambda"
		"capLambda"
		"mu"
		"nu"
		"xi"
		"capXi"
		"pi"
		"capPi"
		"rho"
		"sigma"
		"capSigma"
		"tau"
		"upsilon"
		"capUpsilon"
		"phi"
		"varphi"
		"capPhi"
		"chi"
		"psi"
		"capPsi"
		"omega"
		"capOmega"}}
		
	{menu Symbols {
		"nabla"
		"cross"
		"scriptL"
		"partial"
		"alignEqual"
		"conjugate"
		"infinity"}}
		
	"(-"
	
	{menu MathFunctions {
		"squareRoot"
		"fraction"
		"superscript"
		"subscript"
		"(-"
		"sum"
		"integral"
		"(-"
		"overline"
		"tilde"
		"hat"
		"(-"
		"bigParens"
		"bigBrackets"
		"bigBraces"
		"expectedValue"}}

	{menu MiscFunctions {
		"boldface"
		"emphasize"
		"underline"
		"cite"
		"item"
		"ref"
		"noNumber"}}
		
	{menu Environs {
		"mathMode"
		"mbox"
		"(-"
		"equation"
		"displaymath"
		"eqnarray"
		"eqnarrayStar"
		"environment"}}
}




#
# Special key bindings follow.
# <o> = option, <z> = control, <s> = shift, <c> = command
#
proc bindTexKeys {} {
	bind 'a' <o> alpha 			"Tex"
	bind 'b' <o>	beta 			"Tex"
	bind 'b' <co>    boldface		"Tex"
	bind 'c' <o>	chi			"Tex"
	bind 'd' <o>	delta			"Tex"
	bind 'd' <os>	capDelta		"Tex"
	bind 'e' <o>	epsilon		"Tex"
	bind 'e' <oz>	varepsilon		"Tex"
	bind 'f' <o>	phi			"Tex"
	bind 'f' <oz>    varphi			"Tex"
	bind 'f' <os>	capPhi		"Tex"
	bind 'g' <o>	gamma			"Tex"
	bind 'g' <os>	capGamma		"Tex"
	bind 'h' <o>	eta			"Tex"
	bind 'i' <o>	iota			"Tex"
	bind 'i' <co>    emphasize		"Tex"
	bind 'j' <o>	partial		"Tex"
	bind 'k' <o>	kappa			"Tex"
	bind 'l' <o>	lambda		"Tex"
	bind 'l' <os>	capLambda		"Tex"
	bind 'm' <o>	mu			"Tex"
	bind 'n' <o>	nu			"Tex"
	bind 'p' <o>	pi			"Tex"
	bind 'p' <os>	capPi			"Tex"
	bind 'q' <o>	theta			"Tex"
	bind 'q' <os>	capTheta		"Tex"
	bind 'q' <oz>    vartheta		"Tex"
	bind 'r' <o>	rho			"Tex"
	bind 's' <o>	sigma			"Tex"
	bind 's' <os>	capSigma		"Tex"
	bind 't' <o>	tau			"Tex"
	bind 'u' <o>	upsilon		"Tex"
	bind 'u' <os>	capUpsilon		"Tex"
	bind 'u' <co>     underline		"Tex"
	bind 'v' <o>	nabla			"Tex"
	bind 'w' <o>	omega			"Tex"
	bind 'w' <os>	capOmega		"Tex"
	bind 'x' <o>	xi			"Tex"
	bind 'x' <os>	capXi			"Tex"
	bind 'y' <o>	psi			"Tex"
	bind 'y' <os>	capPsi		"Tex"
	bind 'z' <o>	zeta			"Tex"
	bind '`' <o>   tilde          	"Tex"
	bind '.' <o>	subscript		"Tex"
	bind '=' <o> 	alignEqual 		"Tex"
	bind '\' <o> 	noNumber		"Tex"
	bind 'l' <oz> 	scriptL		"Tex"
	bind '-' <os>	underline		"Tex"
	bind '8' <o>	conjugate		"Tex"
	bind '=' <os>    sum			"Tex"
	bind '/' <os>    mbox			"Tex"
	bind '-' <o>     overline		"Tex"
	bind '\[' <o>     bigBrackets		"Tex"
	bind '3' <o>     item			"Tex"
	bind '0x27' <so>   cross           	"Tex"
	bind '2' <o>     squareRoot		"Tex"
	bind '/' <o>     fraction		"Tex"
	bind '.' <os>    superscript		"Tex"
	bind '\;' <o>   integral        	"Tex"
	bind '4' <o>     mathMode		"Tex"
	bind '5' <o>     infinity		"Tex"
	bind '6' <o>     hat			"Tex"
	bind '9' <os>    bigParens		"Tex"
	bind '\[' <os>    bigBraces		"Tex"
	bind ',' <os>    expectedValue	"Tex"
	bind F5  <o>     equation       	"Tex"
	bind F5 <os>   displaymath     	"Tex"
	bind '5' <co>    equation		"Tex"
	bind '5' <cso>   displaymath		"Tex"
	bind F6 <o>      eqnarray        	"Tex"
	bind F6 <os>   eqnarrayStar    	"Tex"
	bind '6' <co>    eqnarray		"Tex"
	bind '6' <cso>   eqnarrayStar		"Tex"
	bind F7  <o>     environment      	"Tex"
	bind '7' <co>    environment		"Tex"
	bind F8 <o>   	ref              	"Tex"
	bind F8 <os> cite             	"Tex"
	bind '8' <co>    ref   			"Tex"
	bind '8' <cso>   cite			"Tex"
	bind '0x30'   	funcTab		"Tex"
}

